delay_short:	; Short delay
	mov 052h,#150
delay_short01:
	djnz 052h,delay_short01
	ret

	
delay_long:	; Long delay
	mov 055h,#255
delay_long01:
	mov 056h,#255
delay_long02:	
	djnz 056h,delay_long02
	
	djnz 055h,delay_long01
	ret
m5_rx:
	db 0a2h,092h,033h,0dah,05h,07ah,08h,0f0h,0a3h,032h
	db 0c2h,08ch,075h,08ah,01h,0d2h,08ch,032h,0

	
conv_lut:		; Lookup table to convert ASCII to binary
   ; Conventions of this LUT is as following:
   ; if a symbol is to be converted to binary it will be it's binary value 
   ; if a symbol is not converted to binary (not within 0-9,a-f,A-F)
   ; there will be 10h in it's place
   ; This LUT is 128bytes
   
	db 10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h	;0-fh
	db 10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h	;10h-1fh
	db 10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h	;20h-2fh
	db 0,1,2,3,4,5,6,7,8,9,10h,10h,10h,10h,10h,10h				;30h-3fh
	db 10h,10,11,12,13,14,15,10h,10h,10h,10h,10h,10h,10h,10h,10h		;40h-4fh
	db 10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h	;50h-5fh
	db 10h,10,11,12,13,14,15,10h,10h,10h,10h,10h,10h,10h,10h,10h		;60h-6fh
	db 10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h,10h	;70h-7fh

convert_to_binary:
   ; This subroutine is to convert content of Serial buffer from ASCII to binary
   ; First byte isn't converted as it contains code of operation.
   ; Number of bytes to convert is in 05bh
   ; NOTE that one binary byte contains two ASCII bytes thus after conversion
   ; size of data will be shrunk twice
  	
	mov a,05bh	
	jz convert_to_binary_exit	; If we received zero bytes - nothing to convert
	
   	mov r0,#r0_init 	; Reinit beginning of the buffer with ASCII data
	mov r1,#r1_init		; Init pointer to binary data
	inc r0			; First  ASCII byte is not converted
	inc r1			; Reserve also one byte to write number of bytes converted
convert_to_binary_start:
	mov 05ch,@r0		; Copy first two ASCII bytes to be converted into one binary 
	inc r0			; byte
	mov 05dh,@r0
	inc r0
	mov dptr,#conv_lut
	mov a,05ch
	movc a,@a+dptr
	swap a
	mov 05eh,a
	mov a,05dh
	movc a,@a+dptr
	add a,05eh
	mov @r1,a
	inc r1
	djnz 05bh,convert_to_binary_next
	sjmp convert_to_binary_count
   ; This is done to prevent program locking up when number of bytes to convert is even
convert_to_binary_next:
	djnz 05bh,convert_to_binary_start
   ; Otherwise count number of bytes converted
convert_to_binary_count:
   	dec r1	; First byte wasn't converted
	mov a,r1
	clr c
	subb a,#r1_init
	mov r1,#r1_init
	mov @r1,a	; Write back number of bytes converted
convert_to_binary_exit:
	ret
